//
//  MoonPhase.m
//  MoonPhase
//
//  Created by James Dessart on 04/09/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "MoonPhase.h"

#include "phase_of_the_moon.h"

#define SOURCE_IMAGE_SIZE	315

@implementation MoonPhase

- (NSData*)imageData
{
	return [[self imageForCurrentPhase] TIFFRepresentation];
}

- (NSImage*)imageForCurrentPhase
{
	// Image indexes for return values of phase_of_the_moon:
	// 0 = 23
	// 1 = 2
	// 2 = 5
	// 3 = 8
	// 4 = 11
	// 5 = 14
	// 6 = 17
	// 7 = 20
	int phase = phase_of_the_moon();
	int index = ((phase * 3) - 1) % 24;
	int left = (index & 3) * 315;
	int top = (index >> 2) * 315;

	NSRect sourceRect = { {left, top}, {SOURCE_IMAGE_SIZE,SOURCE_IMAGE_SIZE}};
	NSImage *source = [NSImage imageNamed:@"Moon_phases.jpg"];
	
	NSSize imageSize = {128, 128};
	NSRect destRect = { {0,0}, imageSize };
	NSImage *phaseImage = [[NSImage alloc] initWithSize:imageSize];
	
	[phaseImage lockFocus];
	
	if( [source isValid] == YES )
	{
		[source drawInRect:destRect fromRect:sourceRect operation:NSCompositeCopy fraction:1.0];
	}
	else
	{
		assert(1==0);
	}
	
	[phaseImage unlockFocus];
	
	return [phaseImage autorelease];
}

@end
